makepackage.sh revision d2b33d19926987c34b5386feb89f6b93ada0e8f2
## @file
# Sun xVM VirtualBox
# VirtualBox package creation script, Solaris hosts.
#
#
# Copyright (C) 2007-2008 Sun Microsystems, Inc.
#
# This file is part of VirtualBox Open Source Edition (OSE), as
# available from http://www.virtualbox.org. This file is free software;
# General Public License (GPL) as published by the Free Software
# Foundation, in version 2 as it comes in the "COPYING" file of the
# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
#
# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
# Clara, CA 95054 USA or visit http://www.sun.com if you need
# additional information or have any questions.
#
#
# Usage:
# makespackage.sh [--hardened] $(PATH_TARGET)/install packagename {$(KBUILD_TARGET_ARCH)|neutral} $(VBOX_SVN_REV) [VBIPackageName]
# Parse options.
HARDENED=""
while test $# -ge 1;
do
case "$1" in
--hardened)
HARDENED=1
;;
*)
break
;;
esac
shift
done
if [ -z "$4" ]; then
echo "Usage: $0 installdir packagename x86|amd64 svnrev [VBIPackage]"
echo "-- packagename must not have any extension (e.g. VirtualBox-SunOS-amd64-r28899)"
exit 1
fi
# VBOX_PKG_ARCH is currently unused.
VBOX_SVN_REV=$4
# check for GNU grep we use which might not ship with all Solaris
if test ! -f "$VBOX_GGREP" && test ! -h "$VBOX_GGREP"; then
echo "## GNU grep not found in $VBOX_GGREP."
exit 1
fi
# check for GNU tar we use which might not ship with all Solaris
if test ! -f "$VBOX_GTAR" && test ! -h "$VBOX_GTAR"; then
echo "## GNU tar not found in $VBOX_GTAR."
exit 1
fi
# bail out on non-zero exit status
set -e
# Fixup filelist using awk, the parameters must be in awk syntax
# params: filename condition action
{
mv -f "tmp-$1" "$1"
}
{
mv -f "tmp-$1" "$1"
}
# prepare file list
cd "$VBOX_INSTALLED_DIR"
echo 'i pkginfo=./vbox.pkginfo' > prototype
echo 'i postinstall=./postinstall.sh' >> prototype
echo 'i preremove=./preremove.sh' >> prototype
echo 'i space=./vbox.space' >> prototype
if test -f "./vbox.copyright"; then
echo 'i copyright=./vbox.copyright' >> prototype
fi
# Relative hardlinks
if test -f $VBOX_INSTALLED_DIR/amd64/VirtualBox || test -f $VBOX_INSTALLED_DIR/i386/VirtualBox; then
fi
fi
if test -f $VBOX_INSTALLED_DIR/amd64/VBoxHeadless || test -f $VBOX_INSTALLED_DIR/i386/VBoxHeadless; then
fi
find . -print | $VBOX_GGREP -v -E 'prototype|makepackage.sh|vbox.pkginfo|postinstall.sh|preremove.sh|ReadMe.txt|vbox.space|vbox.copyright|VirtualBoxKern' | pkgproto >> prototype
# don't grok for the class files
# install the kernel modules to the right place.
filelist_fixup prototype '$3 == "opt/VirtualBox/i386/vboxdrv=i386/vboxdrv"' '$3 = "platform/i86pc/kernel/drv/vboxdrv=i386/vboxdrv"; $6 = "sys"'
filelist_fixup prototype '$3 == "opt/VirtualBox/amd64/vboxdrv=amd64/vboxdrv"' '$3 = "platform/i86pc/kernel/drv/amd64/vboxdrv=amd64/vboxdrv"; $6 = "sys"'
filelist_fixup prototype '$3 == "opt/VirtualBox/i386/vboxflt=i386/vboxflt"' '$3 = "platform/i86pc/kernel/drv/vboxflt=i386/vboxflt"; $6 = "sys"'
filelist_fixup prototype '$3 == "opt/VirtualBox/amd64/vboxflt=amd64/vboxflt"' '$3 = "platform/i86pc/kernel/drv/amd64/vboxflt=amd64/vboxflt"; $6 = "sys"'
filelist_fixup prototype '$3 == "opt/VirtualBox/vboxdrv.conf=vboxdrv.conf"' '$3 = "platform/i86pc/kernel/drv/vboxdrv.conf=vboxdrv.conf"'
filelist_fixup prototype '$3 == "opt/VirtualBox/vboxflt.conf=vboxflt.conf"' '$3 = "platform/i86pc/kernel/drv/vboxflt.conf=vboxflt.conf"'
# hardening requires some executables to be marked setuid.
if test -n "$HARDENED"; then
$VBOX_AWK 'NF == 6 \
&& ( $3 == "opt/VirtualBox/amd64/VirtualBox=amd64/VirtualBox" \
|| $3 == "opt/VirtualBox/amd64/VirtualBox3=amd64/VirtualBox3" \
|| $3 == "opt/VirtualBox/amd64/VBoxHeadless=amd64/VBoxHeadless" \
|| $3 == "opt/VirtualBox/i386/VirtualBox=i386/VirtualBox" \
|| $3 == "opt/VirtualBox/i386/VirtualBox3=i386/VirtualBox3" \
|| $3 == "opt/VirtualBox/i386/VBoxHeadless=i386/VBoxHeadless" \
) \
fi
# desktop links and icons
filelist_fixup prototype '$3 == "opt/VirtualBox/virtualbox.desktop=virtualbox.desktop"' '$3 = "usr/share/applications/virtualbox.desktop=virtualbox.desktop"'
filelist_fixup prototype '$3 == "opt/VirtualBox/VBox.png=VBox.png"' '$3 = "usr/share/pixmaps/VBox.png=VBox.png"'
# zoneaccess SMF manifest
filelist_fixup prototype '$3 == "opt/VirtualBox/virtualbox-zoneaccess.xml=virtualbox-zoneaccess.xml"' '$3 = "var/svc/manifest/application/virtualbox/zoneaccess.xml=virtualbox-zoneaccess.xml"'
# webservice SMF manifest
filelist_fixup prototype '$3 == "opt/VirtualBox/virtualbox-webservice.xml=virtualbox-webservice.xml"' '$3 = "var/svc/manifest/application/virtualbox/webservice.xml=virtualbox-webservice.xml"'
filelist_fixup prototype '$3 == "opt/VirtualBox/smf-vboxwebsrv.sh=smf-vboxwebsrv.sh"' '$3 = "opt/VirtualBox/smf-vboxwebsrv=smf-vboxwebsrv.sh"'
echo " --- start of prototype ---"
echo " --- end of prototype --- "
# explicitly set timestamp to shutup warning
# create the package instance
pkgmk -p $VBOXPKG_TIMESTAMP -o -r .
# translate into package datastream
# $5 if exist would contain the path to the VBI package to include in the .tar.gz
if test -f "$5"; then
else
fi
echo "## Packaging and transfer completed successfully!"
exit $?